package com.example.flutter_files_picker_example

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.text.format.Formatter
import com.example.flutter_files_picker.FlutterFilePickerPlugin
import com.example.flutter_files_picker.filepicker.local.FilePickerConstant
import com.example.flutter_files_picker.filepicker.local.filter.entity.BaseFile
import com.example.flutter_files_picker.filepicker.local.filter.entity.ImageFile

import io.flutter.app.FlutterActivity
import io.flutter.plugins.GeneratedPluginRegistrant
import org.json.JSONArray
import org.json.JSONObject

class MainActivity : FlutterActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        GeneratedPluginRegistrant.registerWith(this)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == Activity.RESULT_OK) {
            if (requestCode == FilePickerConstant.REQUEST_CODE_PICK_FILE) {
                var arrayList = data?.getParcelableArrayListExtra<BaseFile>(FilePickerConstant.RESULT_PICK_FILE)
                if (arrayList != null) {
                    var fileArray = JSONArray()
                    arrayList.forEach {
                        val tmpObj = JSONObject()
                        tmpObj.put("fileSize", Formatter.formatShortFileSize(this, it.size))
                        tmpObj.put("fileUrl", it.path)
                        fileArray.put(tmpObj)
                    }
                    FlutterFilePickerPlugin.result?.success(fileArray.toString())
                } else
                    FlutterFilePickerPlugin.result?.error("NOT_FOUND", "No data Found", null)
            }
        }

    }
}
