import 'package:flutter/material.dart';
import 'package:flutter_files_picker/flutter_files_picker.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  Function onSelectFile = (fileArray) {
    if (fileArray != null) {
      fileArray.forEach((it) => print(it.fileUrl));
    }
  };

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Column(
          crossAxisAlignment: CrossAxisAlignment.center,
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            GestureDetector(
              onTap: () async {
                await FlutterFilePicker.pickImage(
                  onFileSelect: onSelectFile,
                );
              },
              child: Text('Pick Image'),
            ),
            SizedBox(
              height: 20,
            ),
            GestureDetector(
              onTap: () async {
                await FlutterFilePicker.pickVideo(onFileSelect: onSelectFile);
              },
              child: Text('Pick Video'),
            ),
            SizedBox(
              height: 20,
            ),
            GestureDetector(
              onTap: () async {
                await FlutterFilePicker.pickDocument(
                    onFileSelect: onSelectFile);
              },
              child: Text('Pick Document'),
            ),
            SizedBox(
              height: 20,
            ),
            GestureDetector(
              onTap: () async {
                await FlutterFilePicker.pickAny(
                    onSelectFile, [SourceTypes.GALLARY, SourceTypes.DOCUMENTS],
                    showDirectoryFilter: true);
              },
              child: Text('Pick Any'),
            ),
          ],
        ),
      ),
    );
  }
}
